package com.theitbulls.rvdemo;

import android.os.Bundle;
import android.view.View;
import android.widget.Toast;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.appcompat.widget.AppCompatButton;
import androidx.appcompat.widget.AppCompatEditText;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;

public class MainActivity extends AppCompatActivity {
    public Hashtable<Long, Employee> empLists = new Hashtable<>();

    private RecyclerView recyclerView;
    private AppCompatEditText etEmpId;
    private AppCompatEditText etEmpName;
    private AppCompatEditText etEmpSalary;
    private AppCompatEditText etEmpType;

    private boolean toUpdate;
    private Employee employee;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main_activity);

        etEmpId = findViewById(R.id.empId);
        etEmpName = findViewById(R.id.empName);
        etEmpSalary = findViewById(R.id.empSalary);
        etEmpType = findViewById(R.id.empType);

        LinearLayoutManager llm = new LinearLayoutManager(this);
        llm.setOrientation(LinearLayoutManager.VERTICAL);

        recyclerView = findViewById(R.id.rvEmpList);
        recyclerView.setLayoutManager(llm);

        AppCompatButton btnAdd = findViewById(R.id.btnAdd);
        btnAdd.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                try {
                    Employee employee = getEmployee();
                    if(MainActivity.this.employee == null) {
                        // to add record
                        empLists.put(employee.id, employee);
                    } else {
                        // to update record
                        employee.id = MainActivity.this.employee.id;
                        empLists.put(employee.id, employee);
                    }

                    initRecyclerView();
                } catch (Exception e) {
                    Toast.makeText(MainActivity.this, "Record added error: " + e.toString(), Toast.LENGTH_SHORT).show();
                }
            }
        });

    }

    public void edit(Employee employee) {
        this.employee = employee;

        etEmpId.setText(employee.empId);
        etEmpName.setText(employee.name);
        etEmpSalary.setText(String.valueOf(employee.salary));
        etEmpType.setText(String.valueOf(employee.type));
    }

    public void delete(long id) {
        empLists.remove(id);
        initRecyclerView();
    }

    private Employee getEmployee() {
        Employee employee = new Employee();
        employee.id = empLists.size() + 1;

        employee.empId = etEmpId.getText().toString();
        employee.name = etEmpName.getText().toString();

        String salary = etEmpSalary.getText().toString();
        employee.salary = Double.parseDouble(salary);

        String type = etEmpType.getText().toString();
        employee.type = Integer.parseInt(type);
        return employee;
    }

    private void initRecyclerView() {
        List<Employee> items = new ArrayList<>();
        Enumeration<Employee> employees = empLists.elements();
        while(employees.hasMoreElements()) {
            items.add(employees.nextElement());
        }

        EmployeeListAdapter adapter = new EmployeeListAdapter(this, items);
        recyclerView.setAdapter(adapter);
    }
}
